



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>React Router v4 页面传值的三种方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">React Router v4 页面传值的三种方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 20:00:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>传值方法</h3>
<p>1、props.params</p>
<p>使用React router定义路由时，我们可以给指定一个path，然后指定通配符可以携带参数到指定的path：</p>
<div>
<pre class="prettyprint linenums">&lt;Route path='/user/:name' component={UserPage}&gt;&lt;/Route&gt;</pre>
</div>
<p>跳转UserPage页面时，可以这样写：</p>
<div>
<pre class="prettyprint linenums">//link方法<br />
&lt;Link to="/user/sam"&gt;用户&lt;/Link&gt;<br />
//push方法<br />
this.props.history.push("/user/sam");</pre>
</div>
<p>在UserPage页面中通过 this.props.params.name 获取值。</p>
<p>上面的方法可以传递一个或多个值，但是每个值的类型都是字符串，没法传递一个对象,如果要传的话可以将json对象转换为字符串，传递过去之后再将json字符串转换为对象。</p>
<div>
<pre class="prettyprint linenums"> let data = {id:3,name:sam,age:36};<br />
 data = JSON.stringify(data);<br />
 let path = '/user/${data}';

 //在页面中获取值时<br />
 let data = JSON.parse(this.props.params.data);</pre>
</div>
<p>2、query</p>
<p>query方式可以传递任意类型的值，但是页面的URL也是由query的值拼接的，URL很长且是明文传输。</p>
<div>
<pre class="prettyprint linenums">    //定义路由<br />
    &lt;Route path='/user' component={UserPage}&gt;&lt;/Route&gt;

    //数据定义<br />
    let data = {id:3,name:sam,age:36};<br />
    let path = {<br />
        pathname: '/user',<br />
        query: data,<br />
    }

    //页面跳转<br />
    &lt;Link to={path}&gt;用户&lt;/Link&gt;<br />
    this.props.history.push(path);

    //页面取值<br />
    let data = this.props.location.query;<br />
    let {id,name,age} = data;</pre>
</div>
<p>3、state</p>
<p>state方式类似于post，依然可以传递任意类型的数据，而且可以不以明文方式传输。</p>
<div>
<pre class="prettyprint linenums">    //定义路由<br />
    &lt;Route path='/user' component={UserPage}&gt;&lt;/Route&gt;

    //数据定义<br />
    let data = {id:3,name:sam,age:36};<br />
    let path = {<br />
        pathname: '/user',<br />
        state: data,<br />
    }

    //页面跳转<br />
    &lt;Link to={path}&gt;用户&lt;/Link&gt;<br />
    this.props.history.push(path);

    //页面取值<br />
    let data = this.props.location.state;<br />
    let {id,name,age} = data;</pre>
</div>
<p>以上就是react router中页面传值的三种方法。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jm0le9.html">&lbrack;ASP&period;NET MVC&rsqb; ASP&period;NET Identity登入技术应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gkoo78.html">How to &lpar;seriously&rpar; read a scientific paper</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvwomy9.html">c&plus;&plus;获取系统时间（引用别人的博文）</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq41rj0q.html">VS2012下基本类型大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j5gvg8.html">iptables基本操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnlwm6q.html">14个最受欢迎的Python开源框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1r5e39.html">Android开发之IP拨号器原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj63oy9.html">Android（java）学习笔记169：Activity中的onCreate（）方法分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1xgzx8.html">SCGHR 系统设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjmlpj8.html">zIndex属性在IE中无效</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p5ngn8.html">CI Weekly &num;16 &vert;  从另一个角度看开发效率：flow&period;ci 数据统计功能上线</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mpnjj8.html">malloc与new相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kym559.html">GC选择之串行收集与并行收集</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey33le9.html">第二次项目冲刺（Beta阶段）--第三天</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkmgwz8.html">Java并发-任务执行</a>
		</li>
						<li><a href="https://www.batexi.com/a/90regv39.html">MySQL事务提交过程（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q253x1lq.html">CString比较不区分大小写</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjkdlr9.html">i3wm 入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r532req.html">生活工作必备之SMART原则</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gl0x6q.html">【noip模拟赛4】找啊找啊找BF  拓扑排序</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnj73k28.html">org&period;apache&period;ibatis&period;builder&period;IncompleteElementException&colon; Could not find result map com&period;hp&period;entity&period;Emp</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jo7kw8.html">如何在本地搭建DVWA环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mzwxo8.html">24 python初学（异常）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpn6mxq.html">ENABLE&lowbar;DDL&lowbar;LOGGING 参数使用 监控对象的DDL&lpar;在alter 日志记录DDL语句&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zomgovq.html">对分类型变量，进行编码处理&mdash;&mdash;pd&period;get&lowbar;dummies&lpar;&rpar;、LabelEncoder&lpar;&rpar;、oneHotEncoder&lpar;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpmejvq.html">&period;net后台以post方式调用http接口&lbrack;转&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z4zoe9.html">IL指令表</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zxpj59.html">oracle--数据筛选</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpmj30q.html">Unit 4&period;css的导入方式和选择器</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eydm7k9.html">在IIS上搭建WebSocket服务器（一）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
